/*
 *  Versioner 2 Development Code
 *  Copyright (C) 1999 vacuum@technotronic.com
 *
 *  Link with version.lib
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 1, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */	  




#include <iostream.h> 
#include <windows.h>
#include <stdio.h>
#define VERSION "Versioner 0.2"


// prints information about a file

void PrintFindData(FILE *stream2, WIN32_FIND_DATA *findData, char *dirName)
{	
  FILETIME ft;
  SYSTEMTIME st;
  DWORD   dwVerInfoSize;        
  DWORD   dwVerHnd=0;
  BOOL    bRetCode;
  LPSTR   lpBuffer;
  UINT*    dwBytes = new UINT;
  char *fileName;
  char fullName[256];


  if(!GetFullPathName(findData->cFileName,
                      256,
					  fullName,
					  &fileName))
					  // return;
    	
  
  fprintf(stream2, "__________________________________________________________________________\n");
  printf("%s\n",fullName);
  fprintf(stream2, "%s\nSize: %d bytes\n",fullName, findData->nFileSizeLow);
    // ftCreation Time
    FileTimeToLocalFileTime(&findData->ftCreationTime, &ft);
	FileTimeToSystemTime(&ft, &st);
	// printf("Creation Time: %d/%d/%d %d:%d\n", st.wMonth, st.wDay, st.wYear, st.wHour, st.wMinute);
    fprintf(stream2, "Creation Time: %d/%d/%d %d:%d\n", st.wMonth, st.wDay, st.wYear, st.wHour, st.wMinute);
    // ftLastAccessTime
	FileTimeToLocalFileTime(&findData->ftLastAccessTime , &ft);
	FileTimeToSystemTime(&ft, &st);
	// printf("Last Access Time: %d/%d/%d %d:%d\n", st.wMonth, st.wDay, st.wYear, st.wHour, st.wMinute);
    fprintf(stream2, "Last Access Time: %d/%d/%d %d:%d\n", st.wMonth, st.wDay, st.wYear, st.wHour, st.wMinute);
    // ftLastWriteTime 
	FileTimeToLocalFileTime(&findData->ftLastWriteTime, &ft);
	FileTimeToSystemTime(&ft, &st);
	// printf("Last Write Time: %d/%d/%d %d:%d\n", st.wMonth, st.wDay, st.wYear, st.wHour, st.wMinute);
    fprintf(stream2, "Last Write Time: %d/%d/%d %d:%d\n", st.wMonth, st.wDay, st.wYear, st.wHour, st.wMinute);


	dwVerInfoSize = GetFileVersionInfoSize(findData->cFileName, &dwVerHnd);
	if (dwVerInfoSize)
	{
		 LPTSTR   lpstrVffInfo; 
		 
		 HANDLE  hMem;
            hMem = GlobalAlloc(GMEM_MOVEABLE, dwVerInfoSize);
            lpstrVffInfo  = (char *)GlobalLock(hMem);
            GetFileVersionInfo(findData->cFileName, dwVerHnd, dwVerInfoSize, lpstrVffInfo);
     
			// Company Name
			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
                TEXT("\\StringFileInfo\\040904E4\\CompanyName"),
                (LPVOID *)&lpBuffer,                dwBytes);
            if(bRetCode)
            {
                // printf("Company Name: %s\n",lpBuffer);
				fprintf(stream2, "Company Name: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "Company Name:\n");
			// File Description		
			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo, 
              TEXT("\\StringFileInfo\\040904E4\\FileDescription"), 
              (LPVOID *)&lpBuffer, dwBytes);
			if(bRetCode)
            {
                // printf("File Description: %s\n",lpBuffer);
                fprintf(stream2, "File Description: %s\n",lpBuffer);
			}
			else
			fprintf(stream2, "File Description: \n");
			
			// File Version
			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
                TEXT("\\StringFileInfo\\040904E4\\FileVersion"),
                (LPVOID *)&lpBuffer,                dwBytes);
            if(bRetCode)
            {
                // printf("FileVersion: %s\n",lpBuffer);
				fprintf(stream2, "FileVersion: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "FileVersion: \n");

            // Internal Name
            bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
				TEXT("\\StringFileInfo\\040904E4\\InternalName"),
				(LPVOID *)&lpBuffer , dwBytes);

            if(bRetCode)
			{
				// printf("InternalName: %s\n",lpBuffer);
				fprintf(stream2, "InternalName: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "InternalName: \n");

            // LegalCopyright
			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
				TEXT("\\StringFileInfo\\040904E4\\LegalCopyright"),
				(LPVOID *)&lpBuffer , dwBytes);

            if(bRetCode)
			{
				// printf("LegalCopyright: %s\n",lpBuffer);
				fprintf(stream2, "LegalCopyright: %s\n",lpBuffer);
            }
			else
	            fprintf(stream2, "LegalCopyright:\n");

			// OriginalFilename 

			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
				TEXT("\\StringFileInfo\\040904E4\\OriginalFilename"),
				(LPVOID *)&lpBuffer , dwBytes);

            if(bRetCode)
			{
				// printf("OriginalFilename: %s\n",lpBuffer);
				fprintf(stream2, "OriginalFilename: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "OriginalFilename: \n");
            // ProductName 

			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
				TEXT("\\StringFileInfo\\040904E4\\ProductName"),
				(LPVOID *)&lpBuffer , dwBytes);
			
            if(bRetCode)
			{
				// printf("ProductName: %s\n",lpBuffer);
				fprintf(stream2, "ProductName: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "ProductName: \n");

			// ProductVersion
			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
				TEXT("\\StringFileInfo\\040904E4\\ProductVersion"),
				(LPVOID *)&lpBuffer , dwBytes);

            if(bRetCode)
			{
				// printf("ProductVersion: %s\n",lpBuffer);
				fprintf(stream2, "ProductVersion: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "ProductVersion: \n");
			
            // Comments
			            
            bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
                TEXT("\\StringFileInfo\\040904E4\\Comments"),
                (LPVOID *)&lpBuffer,                dwBytes);
            if(bRetCode)
            {
                // printf("Comments: %s\n",lpBuffer);
				fprintf(stream2, "Comments: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "Comments: \n");
	
			// LegalTrademarks 
	        
			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
                TEXT("\\StringFileInfo\\040904E4\\LegalTrademarks"),
                (LPVOID *)&lpBuffer,                dwBytes);
            if(bRetCode)
            {
                // printf("LegalTrademarks: %s\n",lpBuffer);
				fprintf(stream2, "LegalTrademarks: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "LegalTrademarks: \n");
	        
			// PrivateBuild 
	
			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
                TEXT("\\StringFileInfo\\040904E4\\PrivateBuild"),
                (LPVOID *)&lpBuffer,                dwBytes);
            if(bRetCode)
            {
                // printf("PrivateBuild: %s\n",lpBuffer);
				fprintf(stream2, "PrivateBuild: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "PrivateBuild: \n");
			
			// SpecialBuild 
			bRetCode = VerQueryValue((LPVOID)lpstrVffInfo,
                TEXT("\\StringFileInfo\\040904E4\\SpecialBuild"),
                (LPVOID *)&lpBuffer,                dwBytes);
            if(bRetCode)
            {
                // printf("SpecialBuild: %s\n",lpBuffer);
				fprintf(stream2, "SpecialBuild: %s\n",lpBuffer);
            }
			else
				fprintf(stream2, "SpecialBuild: \n");
	}

	// printf("\n\n");
	fprintf(stream2, "\n\n");



}




// Recursively lists directories

void ListDirectoryContents(FILE *stream, char *dirName, char *fileMask)

{

	char curDir[ 256 ];

	char printDir[ 256 ];

	HANDLE fileHandle;

	WIN32_FIND_DATA findData;



	// save current dir so it can restore it

	if( !GetCurrentDirectory( 256, curDir) ) 

		return;

	

	// if the directory name is neither . or .. then

	// change to it, otherwise ignore it

	if( strcmp( dirName, "." ) && 

		strcmp( dirName, ".." ) )

	{

		if( !SetCurrentDirectory( dirName ) ) 

			return;

		if( !GetCurrentDirectory( 256, printDir) ) 

			return;

	}

	else 

		return;



	// Loop through all files looking for 

	// the file name of interest.

	fileHandle = FindFirstFile( fileMask, 

		&findData );

	while ( fileHandle != INVALID_HANDLE_VALUE )

	{

		PrintFindData(stream, &findData, printDir );



  		// loop thru remaining entries in the dir

		if (!FindNextFile( fileHandle, &findData ))

			break;

 	}

	FindClose( fileHandle );



	// Loop through all files in the directory

	// looking for other directories

	fileHandle = FindFirstFile( "*.*", 

		&findData );

	while ( fileHandle != INVALID_HANDLE_VALUE )

	{

		// If the name is a directory,

		// recursively walk it. 

		if( findData.dwFileAttributes &

			FILE_ATTRIBUTE_DIRECTORY )

		{

			ListDirectoryContents(stream, findData.cFileName, fileMask );

		}

  		// loop thru remaining entries in the dir

		if (!FindNextFile( fileHandle, &findData ))

			break;

 	}

	

	// clean up and restore directory

	FindClose( fileHandle );

	SetCurrentDirectory( curDir );

}



int main(int argc, char *argv[])
{
    char *curDir, *findName, *output;
	FILE *stream;
	if (argc!=4)
	{
	printf("\nusage : %s <starting directory> <filemask> <output.txt>\n\n",VERSION);
	printf("vacuum@technotronic.com\n");
	exit(0);
	}
	curDir = argv[1];
	findName = argv[2];
	output = argv[3];
	if( (stream = fopen(output, "w" )) == NULL ) 
    printf( "The file '%s' was not opened\n",output), exit(-1);
 if (!SetCurrentDirectory(curDir))
	{
		printf("Couldn't get the starting directory.\n");
		return(-1);
	}
 else
 {
	ListDirectoryContents(stream, curDir, findName);
	
}	
   fclose(stream);
	return(0);}

